"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _polished = require("polished");

var _componentLink = require("@cloudflare/component-link");

var _componentIcon = require("@cloudflare/component-icon");

var _styleContainer = require("@cloudflare/style-container");

var _componentVisuallyHidden = require("@cloudflare/component-visually-hidden");

var _intlReact = require("@cloudflare/intl-react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var noBarSpace = '12px';

var styles = function styles() {
  return {
    position: 'relative',
    width: '100%'
  };
};

var Bar = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: 'block',
    width: '100%',
    appearance: 'none',
    '&::-webkit-progress-bar': {
      backgroundColor: theme.colors.gray[8],
      color: theme.colors.gray[8]
    },
    '&::-webkit-progress-value': {
      backgroundColor: theme.colors.blue[4],
      color: theme.colors.blue[4],
      transition: 'width 500ms ease'
    },

    /* Mozilla uses progress-bar as the value */
    '&::-moz-progress-bar': {
      backgroundColor: theme.colors.blue[4],
      color: theme.colors.blue[4]
    }
  };
}, 'progress');
var Icon = (0, _styleContainer.createStyledComponent)(function (_ref2) {
  var hide = _ref2.hide;
  return {
    visibility: hide ? 'hidden' : 'visible'
  };
}, _componentIcon.Icon);
var Items = (0, _styleContainer.createStyledComponent)(function () {
  return _objectSpread(_objectSpread({
    listStyle: 'none'
  }, (0, _polished.clearFix)()), {}, {
    margin: 0,
    padding: 0
  });
}, 'ol');
var Item = (0, _styleContainer.createStyledComponent)(function (_ref3) {
  var theme = _ref3.theme,
      width = _ref3.width,
      disabled = _ref3.disabled,
      active = _ref3.active,
      showBar = _ref3.showBar;
  var color = theme.colors.gray[4];

  if (disabled) {
    color = theme.colors.gray[7];
  } else if (active) {
    color = theme.colors.blue[4];
  }

  return {
    width: 'auto',
    float: 'none',
    height: 'auto',
    paddingBottom: 0,
    paddingLeft: 0,
    paddingRight: 0,
    paddingTop: showBar ? theme.space[2] : 0,
    color: color,
    fontSize: theme.fontSizes[3],
    fontWeight: active ? theme.weightBold : theme.fontWeight,
    textAlign: 'center',
    cursor: disabled ? 'default' : 'pointer',
    display: active ? 'list-item' : 'none',
    '&::before': {
      content: 'none'
    },
    tablet: {
      width: width,
      float: 'left',
      display: 'list-item'
    }
  };
}, 'li');

var Progress = /*#__PURE__*/function (_React$Component) {
  _inherits(Progress, _React$Component);

  var _super = _createSuper(Progress);

  function Progress(props) {
    var _this;

    _classCallCheck(this, Progress);

    _this = _super.call(this, props);
    _this.handleClick = _this.handleClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Progress, [{
    key: "handleClick",
    value: function handleClick(step) {
      if (step.id !== this.props.active) {
        this.props.onChange && this.props.onChange(step.id);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          steps = _this$props.steps,
          active = _this$props.active,
          showBar = _this$props.showBar,
          isStepEnabled = _this$props.isStepEnabled;
      var max = steps.length;
      var itemWidth = (1 / max * 100).toFixed(4) + '%';
      var value;
      var items = steps.map(function (step, index) {
        var isActive = step.id === active;
        var isDisabled = isStepEnabled ? !isStepEnabled(step) : step.disabled;
        var isLastStep = index + 1 === steps.length;
        var lastStepId = 'last-progress-step';

        if (isActive) {
          value = index + 1;
        }

        return /*#__PURE__*/_react.default.createElement(Item, {
          key: step.id,
          width: showBar ? itemWidth : 'auto',
          disabled: step.disabled,
          active: isActive
        }, isLastStep && /*#__PURE__*/_react.default.createElement(_componentVisuallyHidden.VisuallyHiddenSpan, {
          id: lastStepId
        }, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
          _: "Last step.",
          id: "accessibility.progressbar.last_step"
        })), /*#__PURE__*/_react.default.createElement(_componentLink.Link, {
          onClick: _this2.handleClick.bind(null, step),
          disabled: isDisabled,
          pr: showBar ? 0 : noBarSpace,
          "aria-current": isActive ? 'step' : undefined,
          "aria-disabled": isDisabled,
          "aria-describedby": isLastStep ? lastStepId : undefined,
          style: {
            textDecoration: isActive ? 'underline' : 'none'
          }
        }, step.label), !showBar && /*#__PURE__*/_react.default.createElement(Icon, {
          type: "right",
          color: "gray.5",
          pr: noBarSpace,
          size: 32,
          mb: "-11px",
          hide: index === steps.length - 1,
          label: ""
        }));
      });
      return /*#__PURE__*/_react.default.createElement("div", {
        className: className
      }, this.props.showBar && /*#__PURE__*/_react.default.createElement(Bar, {
        max: max,
        value: value
      }), /*#__PURE__*/_react.default.createElement(Items, null, items));
    }
  }]);

  return Progress;
}(_react.default.Component);

Progress.propTypes = {
  active: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
  onChange: _propTypes.default.func,
  steps: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
    label: _propTypes.default.node.isRequired,
    disabled: _propTypes.default.bool
  })).isRequired,
  className: _propTypes.default.string,
  showBar: _propTypes.default.bool,
  isStepEnabled: _propTypes.default.func
};
Progress.defaultProps = {
  steps: [],
  showBar: true
};
Progress.displayName = 'Progress';

var _default = (0, _styleContainer.createStyledComponent)(styles, Progress);

exports.default = _default;